/*
 * Fernando Pereira Silveira
 */

const listID = "controledescripts-listaeventos-permitidos";
const listPref = "dom.popup_allowed_events";

var listaEventos;
var tamanhoAnterior;
var eventoSelecionadoD;
var eventoSelecionadoP;

function controledescripts_adicionar_evento()
{
	if (eventoSelecionadoD)
	{
		eventoSelecionadoD = eventoSelecionadoD.toLowerCase();

		if (!estaNaLista(eventoSelecionadoD,listaEventos))
		{
			listaEventos.push(eventoSelecionadoD);
			listaEventos = listaEventos.sort();
			controledescripts_recarregar_eventos();
		}
		else
			alert(document.getElementById("controledescripts-prefs-strings").getString("controledescripts.alreadyOnList"));
	}
}

function controledescripts_atualizar_botoes()
{
	var botaoAdicionar = document.getElementById("controledescripts-eventos-adicionar");
	var botaoRemover = document.getElementById("controledescripts-eventos-remover");

	if (eventoSelecionadoD)
		botaoAdicionar.disabled = false;
	else
		botaoAdicionar.disabled = true;

	if (eventoSelecionadoP)
		botaoRemover.disabled = false;
	else
		botaoRemover.disabled = true;
}

function controledescripts_atualizar_evento(lista,listaDisponiveis)
{
	if (lista.selectedItem)
		if (listaDisponiveis)
			eventoSelecionadoD = lista.selectedItem.getAttribute("label");
		else
			eventoSelecionadoP = lista.selectedItem.getAttribute("label");

	controledescripts_atualizar_botoes();
}

function controledescripts_carregar_prefs()
{
	var checkList = document.getElementsByTagName("checkbox");
	var inversas  = document.getElementsByAttribute("prefinverse", "true");
	var indice;

	for (indice = 0; indice<checkList.length; indice++)
	{
		if (estaNaLista(checkList[indice],inversas))
		{
			try {checkList[indice].checked = !nsPreferences.getBoolPref(checkList[indice].getAttribute("prefstring"));}
			catch (e) {}
		}
		else
		{
			try {checkList[indice].checked =  nsPreferences.getBoolPref(checkList[indice].getAttribute("prefstring"));}
			catch (e) {}
		}
	}

	listaEventos = nsPreferences.copyUnicharPref(listPref).split(" ");

	if (listaEventos[0] == "")
		listaEventos.splice(0,1);

	tamanhoAnterior = listaEventos.length;

	for (indice in listaEventos)
		document.getElementById(listID).appendItem(listaEventos[indice]);

	controledescripts_atualizar_botoes();
}

function controledescripts_recarregar_eventos()
{
	var lista = document.getElementById(listID);
	var indice;

	for (indice=0; indice<tamanhoAnterior; indice++)
		if (lista.hasChildNodes)
			lista.removeChild(lista.lastChild);

	for (indice in listaEventos)
		lista.appendItem(listaEventos[indice]);

	tamanhoAnterior = listaEventos.length;
	eventoSelecionadoP = null;
	controledescripts_atualizar_botoes();
}

function controledescripts_remover_evento()
{
	var indice;

	if (eventoSelecionadoP)
	{
		for (indice in listaEventos)
			if (listaEventos[indice] == eventoSelecionadoP)
				break;

		listaEventos.splice(indice,1);
		controledescripts_recarregar_eventos();
	}
}

function controledescripts_salvar_prefs()
{
	var checkList = document.getElementsByTagName("checkbox");
	var inversas  = document.getElementsByAttribute("prefinverse", "true");

	for (var indice=0; indice<checkList.length; indice++)
		if (estaNaLista(checkList[indice],inversas))
			nsPreferences.setBoolPref(checkList[indice].getAttribute("prefstring"),!checkList[indice].checked);
		else
			nsPreferences.setBoolPref(checkList[indice].getAttribute("prefstring"), checkList[indice].checked);

	nsPreferences.setUnicharPref(listPref,listaEventos.join(" "));
}

function estaNaLista(elemento,lista)
{
	for (var indice=0; indice<lista.length; indice++)
		if (lista[indice] == elemento)
			return true;

	return false;
}
